// Usage 

// 1. system reset
// CPU_RESET_n button to reset the test code

// 2. LED inidation
// LED[0] : 1pps heart beat
// LED[3:1]:
// light/light/light: no 10MHz input when system boot
// light/unlihgt/unlight: cnt < 9,999,999
// light/light/unlight: cnt = 9,999,999
// unlight/light/unlight: cnt = 10,000,000
// ulight/unlihgt/light: cnt = 10,000,001
// unlight/light/light: cnt > 10,000,001

// 3. SMA Output
// 1PPS if SW[0] is up
// 10MHz if SW[0] is down


//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
//`define ENABLE_PCIE
//`define ENABLE_QDRIIA
//`define ENABLE_QDRIIB
//`define ENABLE_QDRIIC
//`define ENABLE_QDRIID
//`define ENABLE_QSFPA
//`define ENABLE_QSFPB
//`define ENABLE_QSFPC
//`define ENABLE_QSFPD
`define DDR3A_RANK_NUM   1  //2
`define DDR3B_RANK_NUM   1  //2

module DE5A_NET(


      ///////// BUTTON /////////
      input       [3:0]  BUTTON,

      ///////// CLK /////////
      input              CLK_50_B2J,
      input              CLK_50_B2L,
      input              CLK_50_B3D,
      input              CLK_50_B3F,
      input              CLK_50_B3H,
      input              CLK_100_B3D,
      input 	       	 CLKUSR_100,

      ///////// CPU /////////
      input              CPU_RESET_n,

`ifdef ENABLE_DDR3A
      ///////// DDR3A /////////
      output      [15:0] DDR3A_A,
      output      [2:0]  DDR3A_BA,
      output             DDR3A_CAS_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CKE,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CK_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_CS_n,
      output      [7:0]  DDR3A_DM,
      inout       [63:0] DDR3A_DQ,
      inout       [7:0]  DDR3A_DQS,
      inout       [7:0]  DDR3A_DQS_n,
      input              DDR3A_EVENT_n,
      output      [(`DDR3A_RANK_NUM-1):0]  DDR3A_ODT,
      output             DDR3A_RAS_n,
      input              DDR3A_REFCLK_p,
      output             DDR3A_RESET_n,
      output             DDR3A_SCL,
      inout              DDR3A_SDA,
      output             DDR3A_WE_n,
`endif /*ENABLE_DDR3A*/


`ifdef ENABLE_DDR3B
      ///////// DDR3B /////////
      output      [15:0] DDR3B_A,
      output      [2:0]  DDR3B_BA,
      output             DDR3B_CAS_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CKE,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CK_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_CS_n,
      output      [7:0]  DDR3B_DM,
      inout       [63:0] DDR3B_DQ,
      inout       [7:0]  DDR3B_DQS,
      inout       [7:0]  DDR3B_DQS_n,
      input              DDR3B_EVENT_n,
      output      [(`DDR3B_RANK_NUM-1):0]   DDR3B_ODT,
      output             DDR3B_RAS_n,
      input              DDR3B_REFCLK_p,
      output             DDR3B_RESET_n,
      output             DDR3B_SCL,
      inout              DDR3B_SDA,
      output             DDR3B_WE_n,
`endif /*ENABLE_DDR3B*/

      ///////// FAN /////////
      input              FAN_ALERT_n,
      output             FAN_I2C_SCL,
      inout              FAN_I2C_SDA,

      ///////// FLASH /////////
      output      [26:1] FLASH_A,
      output             FLASH_ADV_n,
      output      [1:0]  FLASH_CE_n,
      output             FLASH_CLK,
      inout       [31:0] FLASH_D,
      inout              FLASH_OE_n,
      input       [1:0]  FLASH_RDY_BSY_n,
      output             FLASH_RESET_n,
      output             FLASH_WE_n,

      ///////// HEX0 /////////
      output      [6:0]  HEX0_D,
      output             HEX0_DP,

      ///////// HEX1 /////////
      output      [6:0]  HEX1_D,
      output             HEX1_DP,

      ///////// LED /////////
      output      [3:0]  LED,
      output      [3:0]  LED_BRACKET,
  
`ifdef ENABLE_PCIE
      ///////// OB /////////
      input              OB_PCIE_REFCLK_p,
      ///////// PCIE /////////
      input              PCIE_PERST_n,
      input              PCIE_REFCLK_p,
      input       [7:0]  PCIE_RX_p,
      input              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output      [7:0]  PCIE_TX_p,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

      ///////// POWER /////////
      input              POWER_MONITOR_ALERT,
      output             POWER_MONITOR_I2C_SCL,
      inout              POWER_MONITOR_I2C_SDA,

`ifdef ENABLE_QDRIIA
      ///////// QDRIIA /////////
      output      [21:0] QDRIIA_A,
      output      [1:0]  QDRIIA_BWS_n,
      input              QDRIIA_CQ_n,
      input              QDRIIA_CQ_p,
      output      [17:0] QDRIIA_D,
      output             QDRIIA_DOFF_n,
      output             QDRIIA_K_n,
      output             QDRIIA_K_p,
      output             QDRIIA_ODT,
      input       [17:0] QDRIIA_Q,
      input              QDRIIA_QVLD,
      input              QDRIIA_REFCLK_p,
      output             QDRIIA_RPS_n,
      output             QDRIIA_WPS_n,
`endif /*ENABLE_QDRIIA*/

`ifdef ENABLE_QDRIIB
      ///////// QDRIIB /////////
      output      [21:0] QDRIIB_A,
      output      [1:0]  QDRIIB_BWS_n,
      input              QDRIIB_CQ_n,
      input              QDRIIB_CQ_p,
      output      [17:0] QDRIIB_D,
      output             QDRIIB_DOFF_n,
      output             QDRIIB_K_n,
      output             QDRIIB_K_p,
      output             QDRIIB_ODT,
      input       [17:0] QDRIIB_Q,
      input              QDRIIB_QVLD,
      input              QDRIIB_REFCLK_p,
      output             QDRIIB_RPS_n,
      output             QDRIIB_WPS_n,
`endif /*ENABLE_QDRIIB*/

`ifdef ENABLE_QDRIIC
      ///////// QDRIIC /////////
      output      [21:0] QDRIIC_A,
      output      [1:0]  QDRIIC_BWS_n,
      input              QDRIIC_CQ_n,
      input              QDRIIC_CQ_p,
      output      [17:0] QDRIIC_D,
      output             QDRIIC_DOFF_n,
      output             QDRIIC_K_n,
      output             QDRIIC_K_p,
      output             QDRIIC_ODT,
      input       [17:0] QDRIIC_Q,
      input              QDRIIC_QVLD,
      input              QDRIIC_REFCLK_p,
      output             QDRIIC_RPS_n,
      output             QDRIIC_WPS_n,
`endif /*ENABLE_QDRIIC*/

`ifdef ENABLE_QDRIID
      ///////// QDRIID /////////
      output      [21:0] QDRIID_A,
      output      [1:0]  QDRIID_BWS_n,
      input              QDRIID_CQ_n,
      input              QDRIID_CQ_p,
      output      [17:0] QDRIID_D,
      output             QDRIID_DOFF_n,
      output             QDRIID_K_n,
      output             QDRIID_K_p,
      output             QDRIID_ODT,
      input       [17:0] QDRIID_Q,
      input              QDRIID_QVLD,
      input              QDRIID_REFCLK_p,
      output             QDRIID_RPS_n,
      output             QDRIID_WPS_n,
`endif /*ENABLE_QDRIID*/

`ifdef ENABLE_QSFPA
      ///////// QSFPA /////////
      input              QSFPA_INTERRUPT_n,
      output             QSFPA_LP_MODE,
      input              QSFPA_MOD_PRS_n,
      output             QSFPA_MOD_SEL_n,
      input              QSFPA_REFCLK_p,
      output             QSFPA_RST_n,
      input       [3:0]  QSFPA_RX_p,
      output             QSFPA_SCL,
      inout              QSFPA_SDA,
      output      [3:0]  QSFPA_TX_p,
`endif /*ENABLE_QSFPA*/

`ifdef ENABLE_QSFPB
      ///////// QSFPB /////////
      input              QSFPB_INTERRUPT_n,
      output             QSFPB_LP_MODE,
      input              QSFPB_MOD_PRS_n,
      output             QSFPB_MOD_SEL_n,
      input              QSFPB_REFCLK_p,
      output             QSFPB_RST_n,
      input       [3:0]  QSFPB_RX_p,
      output             QSFPB_SCL,
      inout              QSFPB_SDA,
      output      [3:0]  QSFPB_TX_p,
`endif /*ENABLE_QSFPB*/

`ifdef ENABLE_QSFPC
      ///////// QSFPC /////////
      input              QSFPC_INTERRUPT_n,
      output             QSFPC_LP_MODE,
      input              QSFPC_MOD_PRS_n,
      output             QSFPC_MOD_SEL_n,
      input              QSFPC_REFCLK_p,
      output             QSFPC_RST_n,
      input       [3:0]  QSFPC_RX_p,
      output             QSFPC_SCL,
      inout              QSFPC_SDA,
      output      [3:0]  QSFPC_TX_p,
`endif /*ENABLE_QSFPC*/

`ifdef ENABLE_QSFPD
      ///////// QSFPD /////////
      input              QSFPD_INTERRUPT_n,
      output             QSFPD_LP_MODE,
      input              QSFPD_MOD_PRS_n,
      output             QSFPD_MOD_SEL_n,
      input              QSFPD_REFCLK_p,
      output             QSFPD_RST_n,
      input       [3:0]  QSFPD_RX_p,
      output             QSFPD_SCL,
      inout              QSFPD_SDA,
      output      [3:0]  QSFPD_TX_p,
`endif /*ENABLE_QSFPD*/

		 //////////// RS422 //////////
		 //output		          		RJ45_LED_R,
		 //output		          		RS422_RE_n,

       input          PPS_CLK,  //output  RS422_DE,
       output         UART_TX,  //input 	RS422_DIN,
       input          UART_RX,  //output	RS422_DOUT,
       input          M10_CLK,  //output	RJ45_LED_L,

      ///////// RZQ /////////
      input              RZQ_DDR3_A,
      input              RZQ_DDR3_B,
      input              RZQ_QDRII_A,
      input              RZQ_QDRII_B,
      input              RZQ_QDRII_C,
      input              RZQ_QDRII_D,

      ///////// SI5340A /////////
      output             SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_INTR,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// SI5340B /////////
      output             SI5340B_I2C_SCL,
      inout              SI5340B_I2C_SDA,
      input              SI5340B_INTR,
      output             SI5340B_OE_n,
      output             SI5340B_RST_n,

      ///////// SMA /////////
      input              SMA_CLKIN,
      output             SMA_CLKOUT,

      ///////// SW /////////
      input       [1:0]  SW,

      ///////// TEMP /////////
      output             TEMP_I2C_SCL,
      inout              TEMP_I2C_SDA,
      input              TEMP_INT_n,
      input              TEMP_OVERT_n

);



//=======================================================
//  REG/WIRE declarations
//=======================================================

`define CNT_DESIRE			24'd10000000
`define CNT_LESS_9999999	3'd0
`define CNT_9999999			3'd1
`define CNT_10000000			3'd2
`define CNT_10000001			3'd3
`define CNT_MORE_10000001	3'd4

`define CNT_100M				27'd100000000

//=======================================================

//  Structural coding
//=======================================================


////////////////////////////////////
// check 10MHz clock input stauts
reg			no_10M_clk/*synthesis noprune*/;

reg pre_M10_CLK;
always @(posedge CLK_50_B3D or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		pre_M10_CLK <= 1'b0;
	else
		pre_M10_CLK <= M10_CLK;
		
end


reg [2:0] tick_50m_for_10m/*synthesis noprune*/;
always @(posedge CLK_50_B3D or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
	begin
		no_10M_clk <= 1'b1;
		tick_50m_for_10m <= 0;
	end
	else if (pre_M10_CLK ^ M10_CLK)
	begin
		no_10M_clk <= 1'b0;
		tick_50m_for_10m <= 0;
	end
	else if (tick_50m_for_10m == 3'd7)
		no_10M_clk <= 1'b1;
	else
		tick_50m_for_10m <= tick_50m_for_10m + 1;
		
end

////////////////////////////////////
// check 1PPS clock input stauts
reg			no_1PPS_clk/*synthesis noprune*/;

reg pre_1PPS_CLK;
always @(posedge CLK_50_B3D or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		pre_1PPS_CLK <= 1'b0;
	else
		pre_1PPS_CLK <= PPS_CLK;
		
end


reg [25:0] tick_50m_for_1pps;
always @(posedge CLK_50_B3D or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
	begin
		no_1PPS_clk <= 1'b1;
		tick_50m_for_1pps <= 0;
	end
	else if (pre_1PPS_CLK ^ PPS_CLK)
	begin
		no_1PPS_clk <= 1'b0;
		tick_50m_for_1pps <= 0;
	end
	else if (tick_50m_for_1pps == 26'h3FFFFFF)
		no_1PPS_clk <= 1'b1;
	else
		tick_50m_for_1pps <= tick_50m_for_1pps + 1;
		
end


////////////////////////////////////////////////////////
// function: 
// drive a PLL off the 10 MHz clock and pulse an LED when the 1 pps clock goes high
////////////////////////////////////////////////////////
wire pll_locked;
wire clk_10_global;
wire clk_100;

	ctrl_10m ctrl_10m_inst (
		.inclk  (M10_CLK),  //  altclkctrl_input.inclk
		.outclk (clk_10_global)  // altclkctrl_output.outclk
	);


	pll_sys pll_100Mhz (
		.rst      (~CPU_RESET_n),      //   reset.reset
		.refclk   (clk_10_global),   //  refclk.clk
		.locked   (pll_locked),   //  locked.export
		.outclk_0 (clk_100)  // outclk0.clk
	);
	
reg pre_1pps_100m;	
always @(posedge clk_100 or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		pre_1pps_100m <= 1'b0;
	else
		pre_1pps_100m <= PPS_CLK;
end	

reg [26:0]	cnt_100m/*synthesis noprune*/;
always @(posedge clk_100 or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		cnt_100m <= 0;
	else if (~pre_1pps_100m & PPS_CLK)
		cnt_100m <= 0; // 1pps start
	else if (cnt_100m < `CNT_100M)
		cnt_100m <= cnt_100m + 1;
end	

wire turn_on_led;
assign turn_on_led = (cnt_100m < `CNT_100M/2)?1'b1:1'b0;
assign LED[0] = ((~no_1PPS_clk & ~no_10M_clk & turn_on_led) | ~CPU_RESET_n)?1'b0:1'b1; // led is low active


////////////////////////////////////////////////////////
// function:
// count 10 MHz clock pulses and see if you get more or less than 10 million such pulses each clock cycle
////////////////////////////////////////////////////////
////////////////////////////////////
// count M10_CLK
wire cnt_reset/* synthesis keep */;
wire [23:0]	cnt/* synthesis keep */;	
assign cnt_reset = pps_rise | ~CPU_RESET_n;
	count_10mhz count (
		.clock (M10_CLK), //  counter_input.clock
		.sset  (cnt_reset),  // reset the count to 1
		.q     (cnt)      // counter_output.q
	);
	
reg pre_1pps;	
always @(posedge M10_CLK or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		pre_1pps <= 1'b0;
	else
		pre_1pps <= PPS_CLK;
end



wire pps_rise/* synthesis keep */;
assign pps_rise = ~pre_1pps & PPS_CLK;
reg [2:0] 	result/*synthesis noprune*/;
reg skip_first_time/*synthesis noprune*/;
always @(posedge M10_CLK or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
	begin
		result <= `CNT_10000000;
		skip_first_time <= 1'b1;
	end
	else if (pps_rise && skip_first_time)
		skip_first_time <= 1'b0;
	else if (pps_rise && (result == `CNT_10000000))
	begin
		if (cnt < `CNT_DESIRE-1)
			result <= `CNT_LESS_9999999;
		else if (cnt == `CNT_DESIRE-1)
			result <= `CNT_LESS_9999999;
		else if (cnt == `CNT_DESIRE)
			result <= `CNT_10000000;
		else if (cnt == `CNT_DESIRE+1)
			result <= `CNT_10000001;
		else
			result <= `CNT_MORE_10000001;
	
	end
end	



reg [19:0] sec_cnt/*synthesis noprune*/;
always @(posedge M10_CLK or negedge CPU_RESET_n)
begin
	if (~CPU_RESET_n)
		sec_cnt <= 0;
	else if (pps_rise)
		sec_cnt <= sec_cnt + 1;
end	


reg [2:0] led_x3;
always @(*)
begin
	if (~CPU_RESET_n)
		led_x3 <= 3'b111;
	else
	begin
	case(result)
		`CNT_LESS_9999999	: led_x3 <= 3'b100;
		`CNT_9999999     	: led_x3 <= 3'b110;
		`CNT_10000000		: led_x3 <= 3'b010;
		`CNT_10000001		: led_x3 <= 3'b011;
		`CNT_MORE_10000001: led_x3 <= 3'b001;
	endcase
	end
end

// trun all three led off if 1pps or 10M are missed
assign LED[3:1] = ~CPU_RESET_n ?3'b000:((no_1PPS_clk | no_10M_clk)?3'b111:((skip_first_time)?3'b000:~led_x3)); // led is low active



////////////////////////////////////////////////////////
// function: 
// replicate either pulse to the SMA output
////////////////////////////////////////////////////////
// SMA ouput: internal loopback 1PPS or M10_CLK
wire sma_out_1pps;
assign sma_out_1pps = SW[0]; // switch up
assign SMA_CLKOUT = sma_out_1pps?PPS_CLK:M10_CLK;





endmodule

