module CHECK_D001 ( 
 input          CLK_50 , 
 input   [1:0]  SW	 , 
 input          SMA_IN , 
 output reg     rSMA_IN ,
 input          RESET_N,
 output         TR,
 output reg [ 23:0 ]  T_CNT  , 
 	output [ 23:0] M10_RESULT_CNT,
	output         M10_READY     ,	
 
 
 output reg READY  , 
 output reg rFG,  
 output     TIME_OUT, 
 output     ERROR_FG   
);

 	reg [ 23:0] rM10_RESULT_CNT;
	reg         rM10_READY     ;	


//=======================================================
//  REG/WIRE declarations
//=======================================================

//parameter   MAIN_CK =10000000; 
parameter   SEC1    =50000000 ; 
parameter   SEC2    =50000000 *2 ;//important 

wire        SEC; 
wire [31:0] ERR_CK; 
reg  [1:0 ] rSEC ; 
wire [31:0] MAX_CK, MAX_CK1,MAX_CK2 ;

//=======================================================

//  Structural coding
//=======================================================



assign ERR_CK  =  ( 
    (SW==0)?12: (    //1K
    (SW==1)?9: (    //100
    (SW==2)?3: (    //10
    (SW==3)?1:1      //0
))));

assign  MAX_CK  = 10000000; 
assign  MAX_CK1 = MAX_CK - ERR_CK ;
assign  MAX_CK2 = MAX_CK + ERR_CK ;


assign M10_RESULT_CNT  = ERROR_FG? ( TIME_OUT? 24'hffffff :  rM10_RESULT_CNT )  : rM10_RESULT_CNT ; 
assign M10_READY       = ERROR_FG? SEC : rM10_READY ; 


assign ERROR_FG = TIME_OUT |  rFG; // 
//---
CLOCKMEM ck1( .RESET_N( RESET_N  ) , .CLK ( CLK_50 ) ,.CLK_FREQ ( 400000000 ) , .CK_1HZ (SEC) ) ;  


TIME_OUR tr( 
  .CLK_50  (CLK_50   ), 
  .RESET_N (RESET_N  ),  
  .SMA_IN  (SMA_IN  ), 
  .SEC     (400000000 ), 
  .TIME_OUT(TIME_OUT ),
) ;

  
 
//---
assign TR  =  ( rSEC &&  !SEC  )? 1:0 ;  
always @ ( negedge RESET_N   or posedge  SMA_IN   ) begin
if (!RESET_N) begin
    T_CNT <=0;  
	 rSEC  <=0 ; 
	 rFG   <= 0;
	 READY <= 0; 
end 
else  begin 
    rSEC  <= SEC ;
    if  ( TR )  begin 
		 if ( READY &&  (( T_CNT < MAX_CK1 ) ||  ( T_CNT >  MAX_CK2 ) ) )  rFG <= 1 ; 
		      READY  <=1; 
            
				{ rM10_RESULT_CNT , T_CNT } <= { T_CNT , 24'h0 } ; 
 	           rM10_READY     <=1 ;			
	 end  
	 else  begin 
	    rM10_READY  <=0 ;
	    if  ( READY  &&  ( T_CNT < 20000000) )    T_CNT  <= T_CNT+1 ; 
	 end 	
end 
end	 

endmodule
