module CLOCK_GEN  ( 
    input  RESET_N , 
    input  SW , 
    input  CLK_50  , 
    output CLK_OUT  

); 


//=======================================================
//  REG/WIRE declarations
//=======================================================

wire   CK_200 ; 
wire   CK_400 ; 
wire 	 TE_1HZ ; 
wire 	 TE_10MHZ ; 
//=======================================================

//  Structural coding
//=======================================================

//-- pll generator  200MHZ /4000MHZ 
 PLL LK(
	 .rst       ( ~RESET_N),
	 .refclk    ( CLK_50 ) ,
	 .locked    ( ),
	 .outclk_0  ( CK_200 ),
	 .outclk_1  ( CK_400 ) 		
	);

//--1hz generator 	
CLOCKMEM ck5(  
    .CLK       ( CLK_50   ),
    .CLK_FREQ  ( 50000000 ),
    .CK_1HZ    ( TE_1HZ)  ) ; 
  
//--10Mhz generator 
CLOCKMEM ck6(  
    .CLK       (  CK_200  ) ,
    .CLK_FREQ  (  19      ),
    .CK_1HZ    (  TE_10MHZ) 
 ) ; 

 //---TEST OUT CLOCK---

assign   CLK_OUT = SW?TE_1HZ: TE_10MHZ;

endmodule 