module PPS_CHECK ( 
 input  CLK_50 , 
 input      SMA_IN , 
 output reg [1:0] rSMA_IN ,
 input  RESET_N,
 output reg [ 31:0 ] T_CNT  ,
 output reg [1:0] READY  , 
 output reg rFG, 
 output reg TIME_OUT, 
 output      ERROR_FG ,
 input [1:0] SW
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
parameter MAIN_CK =50000000*8 ;   //400MHZ 
parameter SEC1    =50000000*8 ; 
parameter SEC2    =50000000*16 ;  //important 


wire [31:0] ERR_CK; 
wire        SEC; 
reg  [31:0] DELAY ; 
reg         rSEC ; 
wire        TR ;


//=======================================================

//  Structural coding
//=======================================================

assign ERROR_FG   = TIME_OUT |  rFG; // 


assign ERR_CK  =   ( 
(SW==0)?400 *8:    (  //1K
(SW==1)?300 *8:    (  //100
(SW==2)?200 *8:    (  //10
(SW==3)?100 *8:8*100  //0
))));


//---
CLOCKMEM ck1(  .RESET_N(  RESET_N) , .CLK ( CLK_50  ) ,. CLK_FREQ ( 400000000 ) , .CK_1HZ (SEC) ) ;  

assign TR = ( rSMA_IN  == 2'b10  )?1:0 ;  
//-- 
always @ ( negedge RESET_N or posedge  CLK_50  ) begin
if (!RESET_N) begin 
      rSEC          <= SEC   ;  
	   T_CNT         <= 32'h0 ;
	   rFG           <= 0;
		rSMA_IN       <= 0; 
		DELAY         <= 0;
		TIME_OUT      <= 0;
		READY         <= 0; 
end 
else begin 
      rSEC     <= SEC ; 
		rSMA_IN [1:0]  <= { rSMA_IN [0]  , SMA_IN }  ; 
//---time out 
	   if ( DELAY < SEC2 )  begin
	   	if ( TR )  
			        DELAY <=0 ;
		   	else DELAY <= DELAY+1; 
			  TIME_OUT <=0 ;
		  end 	
		else TIME_OUT <=1 ;
//---% check 
     //if ( !rSMA_IN  && SMA_IN )  begin 
	  if ( TR )  begin 
		     if (  ( READY==2 )  && ( ( T_CNT < ( MAIN_CK -ERR_CK) ) ||  ( T_CNT >  ( MAIN_CK+ ERR_CK) )))  rFG <= 1 ; 
			    if ( READY<2 ) READY  <= READY +1; 
			    T_CNT  <= 0; 
		end 
		else if ( ( READY==2 ) && ( T_CNT < MAIN_CK *2)) T_CNT <=T_CNT+1;
		
end 
end 

endmodule
