module   TIME_ASCII_BCD  (
  input   [7:0] ASCII_RX ,
  input         RESET_N,
  input         CLK ,
  input         LATCH,
  output  [7:0] SS,
  output  [7:0] MM,  
  output  [7:0] HH 
); 

//=======================================================
//  REG/WIRE declarations
//=======================================================
  reg  [7:0]  BYTE   ; 
  reg  [63:0] CLOCK ;
  reg  [7:0]  CM    ; 
  reg  [63:0] CH1   ;	
  
//=======================================================
//  Structural coding
//=======================================================

  assign  SS = { CLOCK[11:8] , CLOCK[3:0] } ; 
  assign  MM = { CLOCK[35:32] , CLOCK[27:24] } ; 
  assign  HH = { CLOCK[59:56] , CLOCK[51:48] } ; 
  
//------    
 always @(negedge RESET_N  or  posedge  CLK )  
 if  ( !RESET_N ) begin 
      CM    <=0;
      CH1   <=0;
      CLOCK <=0; 
		BYTE  <=0; 
 end 
 else begin
      if (BYTE==7 ) CLOCK <=  CH1 ; 
      if (LATCH ) begin 
			     CH1[63:0]<=  { CH1[55:0 ] , ASCII_RX } ; 
				         //{"v","e","g","u","r"}  
			     if   (( CM==0) &&  ( CH1[39:0] == 40'h7665677572 )) CM<=1 ; 
					                                  //\r    \n    \r    \n
					  
				 else if (( CM==1) && ( CH1[31:0] == {8'h0D,8'h0A,8'h0D,8'h0A }  )) begin BYTE<=0; CM<=2 ; end 
			    else if ( CM==2)  	  begin
					   if (  BYTE != 7) begin BYTE <=BYTE +1 ; end 
						  
				end  
	  end  		
end


endmodule 
